function drawColorbar(fid,cMap,radiusOfCircumSphere,settings)
%% low-level function
% internal package function
% input structures described in documentation
%
%  2020, Vojtech Neuman, neumavo1@fel.cvut.cz (2020)

N = size(cMap,1);
barArea = radiusOfCircumSphere^2*(0.15*1.5);
colorArea = barArea / N;
colorSizeA = 0.15*radiusOfCircumSphere;
colorSizeB = colorArea/colorSizeA;
colVecLeft = -0.75*radiusOfCircumSphere:colorSizeB:0.75*radiusOfCircumSphere-colorSizeB;
colVecRight = colVecLeft + colorSizeB;

dataTemp = [255.*cMap...
   1.15*radiusOfCircumSphere*ones(N,1)...
   colVecLeft'...
   1.3*radiusOfCircumSphere*ones(N,1)...
   colVecRight']';
fprintf(fid,['\\fill ['...
   'color={rgb,255:red,%3.4f;'...
   'green,%3.4f;'...
   'blue,%3.4f}] '...
   '(%1.3f,%1.3f) rectangle (%1.3f,%1.3f);\n'],...
   dataTemp);

fprintf(fid,['\\draw [draw=black,fill opacity = 0, line width = %1.4f]'...
   '(%1.4f,%1.4f) rectangle (%1.4f,%1.4f);\n\n'],...
   settings.TikZ_Scale/10,...
   radiusOfCircumSphere*[1.15 -0.75 1.3 0.75]);
end