function [faces_i,edges] = reduceSquare(vert,faces)
%% low-level function
% internal package function
% input structures described in documentation
%
%  2020, Vojtech Neuman, neumavo1@fel.cvut.cz (2020)
warning('off','all')
waitBar = models.utilities.graphics.Waitbar(0, ...
   'Compression', 0, [10 10 350 25], 0);

% ----- data adjust
vert(:,3) = vert(:,3) - min(vert(:,3))-1;
faces_n = size(faces,1);
% faceA = faces(:,[1 2 3])';
% faceB = faces(:,[1 3 4])';
% faces = reshape([faceA;faceB],[3 faces_n*2])';

% ----- direct visibility
cvert = zeros(faces_n,2);
for j = 1:faces_n
   cvert(j,:) = mean(vert(faces(j,:),1:2),1);
end
faces_i = [true; false(faces_n-1,1)];
p = [1 4 2 5 1 4; 2 5 3 6 3 6];
for j = 2:faces_n
   waitBar.update(j/faces_n);
   tri = triangulation(faces(faces_i,:),vert(:,1),vert(:,2));
   nv1 = (0.1*cvert(j,1:2) + 0.9*vert(faces(j,:),1:2));
   nv2 = (0.5*cvert(j,1:2) + 0.5*vert(faces(j,:),1:2));
   nv3 = reshape(mean([nv1(p);nv2(p)]),[2 3])';
   nvert = [nv1; nv2; nv3; cvert(j,1:2)];
   ivert = tri.pointLocation(nvert);
   faces_i(j) = sum(isnan(ivert)) > 0;
end


edges = tri.freeBoundary;
% M_test.edges = edges;
% M_test.vert = vert;
% save('mat','M_test')


faces_i = reshape(faces_i,[2 faces_n/2])';
fprintf(1,'Reduced amount of triangles: %i/%i (%1.2f percent).\n',...
   sum(faces_i(:,1) | faces_i(:,2)),faces_n/2,...
   sum(faces_i(:,1) | faces_i(:,2))/faces_n*100*2);
end