%% TikZ Conversion Functions Example
% Example of usage of plot conversion to TikZ macros.
%
% AToM2TikZ expansion, beta version
%  2020, Vojtech Neuman, neumavo1@fel.cvut.cz (2020)
clc;
clear;
close all;

% Generation of structure
P = 2*ones(5,10);

% Computation of mesh and basis functions structures
[~,~,Mesh] = models.utilities.meshPublic.pixelGridToMesh(P, 1);
BF = models.solvers.MoM2D.basisFcns.getBasisFcns(Mesh);

% Random evaluation of active basis functions
actEdges = unique(randi([1 BF.nUnknowns],[floor(BF.nUnknowns/3) 1]));
temp = false(BF.nUnknowns,1);
temp(actEdges) = true;

% Preparation of data
hndl.Mesh = Mesh;
hndl.BF = BF;
hndl.Temp = temp;
hndl.axes.View = [0 90];
hndl.type = 'topoSens';

export.plot2TikZ(hndl,'TikZ_Scale',1);